// Fragment Shader  file "planet_shader.frag"

#version 330 core

uniform sampler2D color_texture;
uniform sampler2D sm_texture;
uniform float transparency;

in vec3 normal;
in vec4 ex_color;
in vec3 light_direction;
in vec2 ex_texture_coords;
in vec3 eye_direction;
in vec4 sm_tex_coords;

out vec4 out_color;

void main(void)
{
	vec3 tex_coords = sm_tex_coords.xyz/sm_tex_coords.w;
	float depth = texture(sm_texture, tex_coords.xy).r;

	vec3 n = normalize( normal );
	vec3 l = normalize( light_direction );
	float cosTheta = max( dot( l,n ), 0.0 );

	vec4 texel = texture2D(color_texture, ex_texture_coords);

	if (depth < tex_coords.z) {
		out_color = vec4((texel.xyz + ex_color.xyz) * vec3(0.7, 0.7, 1) * 0.05, transparency);
	} else { 
		out_color = vec4((texel.xyz + ex_color.xyz) * vec3(0.7, 0.7, 1) * 0.05 + (ex_color.xyz * 0.2 + texel.xyz * 0.7) * cosTheta * vec3(1, 1, 0.6), transparency);
	}

}
